/*
 * ContourAnalyzer.h
 *
 *  Created on: Apr 22, 2018
 *      Author: Yunyang
 */

#ifndef RECTANGLE_DETECTION_CONTOURANALYZER_H_
#define RECTANGLE_DETECTION_CONTOURANALYZER_H_
#include <string>
#include <opencv2/opencv.hpp>
#include "../UI.h"
#include "../UIListener.hpp"

class ContourAnalyzer: public UIListener {
	int *lastKey;
	bool cannyRec = false, drawContours = false;
	UI *ui;
	std::vector<std::vector<cv::Point>> contours;
	std::vector<std::vector<cv::Point>> inconsistentContours;
	std::vector<std::vector<cv::Point>> consistentContours;
	std::vector<std::vector<cv::Point>> prunedContours;
	std::vector<cv::Rect> bounds;
	std::vector<cv::RotatedRect> rotatedBounds;

	void removeRedundancy();
	void preAnalyze();
public:
	int binLower = 54;

	int minSize = 0;
	int minSizeScale = 18;
	int cannyLower = 45;
	int cannyUpper = 3*cannyLower;

	int epsilon = 56;

	ContourAnalyzer(UI* ui, int *lastKey);
	virtual ~ContourAnalyzer();
	cv::Scalar selectColor { 0, 255, 0 };
	cv::Scalar fontColor { 0, 0, 255 };
	void analyze();
	void analyze(cv::Rect rect);
	void drawContoursOntoMat(cv::Mat &frame);
	std::string contourToString(std::vector<cv::Point>);
	void convertContoursToBounds();
	void convertContoursToRotatedBounds();
	std::vector<cv::Rect> getBounds() const;
	std::vector<cv::RotatedRect> getRotatedBounds() const;
	void componentSetup();
};

#endif /* RECTANGLE_DETECTION_CONTOURANALYZER_H_ */
