#ifndef RECTANGLE_RULER_H_
#define RECTANGLE_RULER_H_
#include "../UI.h"
#include "../UIListener.hpp"

class Ruler: public UIListener {
	cv::Point distanceTextPos {5, 60};
	cv::Point confTextPos {5, 75};
	cv::Scalar textFontColor {20, 20, 20};

	cv::RotatedRect rect;
	UI *ui;
	int *lastKey;
	float distance = 0;
	float givenWidth = 0;
	float focalLength = 0;
	float HFOV = 65;
	bool inputtingVal = false;
	std::deque<char> numBuild;

public:
	Ruler(UI *ui, int *lastKey);
	float estimateFocalLength(float HFOV);
	int estimateDistance(cv::RotatedRect rect);
	void update();
	void updateRectangle(cv::RotatedRect rect);
	void componentSetup();
	void updateUI();
	void toggleInput();
	virtual ~Ruler();

private:
	void inputUpdate();
};

#endif /* RECTANGLE_RULER_H_ */
