/*
 * Webcam.cpp
 *
 *  Created on: Apr 21, 2018
 *      Author: Yunyang
 */

#include "Webcam.h"

Webcam::Webcam(int webcamID) {
	stream = new cv::VideoCapture(webcamID);
	stream->set(cv::CAP_PROP_FRAME_WIDTH, 1920);
	stream->set(cv::CAP_PROP_FRAME_HEIGHT, 1080);
}

void Webcam::update() {
	stream->read(frame);
}

bool Webcam::isConnected() const {
	return webcamConnected;
}

cv::Mat Webcam::getFrame() const {
	return frame;
}

Webcam::~Webcam() {
	delete stream;
}

